#include <iostream>
#include <log4cplus/socketappender.h>		//ネットワークロガー
#include <log4cplus/configurator.h>			//ローカルロガー
#include <log4cplus/spi/loggingevent.h>  
#include <log4cplus/loggingmacros.h>
#include <log4cplus/logger.h>
#include <boost/filesystem.hpp>

namespace FS=boost::filesystem;

int main(){
	FS::path home_folder=std::getenv("HOME");
	FS::path log4_file=home_folder/"log"/"tcp.cfg";
	if (!FS::exists(log4_file))
	{
		std::cerr << "Can not find log4c++ configuration:" << log4_file.string() << std::endl;
		return EXIT_FAILURE;
	}
	log4cplus::PropertyConfigurator config(log4_file.string());
	config.configure();
	log4cplus::initialize();
	log4cplus::Logger logger=log4cplus::Logger::getInstance(LOG4CPLUS_TEXT("tcp"));
	LOG4CPLUS_INFO(logger,"Hell World");   // INFO文字列を出力
	LOG4CPLUS_INFO(logger,std::hex << std::this_thread::get_id() << std::dec << "<<" << "ひゃっはー");
	LOG4CPLUS_WARN(logger,"This is warning"); // ログファイルにWARNをつけて出力
	LOG4CPLUS_ERROR(logger,"This is error"); // ログファイルにERRORをつけて出力
	log4cplus::getNDC().push(LOG4CPLUS_TEXT("con1"));
	LOG4CPLUS_INFO(logger,"コンテキスト・わん");   // INFO文字列を出力
	log4cplus::getNDC().push(LOG4CPLUS_TEXT("con2"));
	LOG4CPLUS_INFO(logger,"だぶるコンテキスト");   // INFO文字列を出力
	log4cplus::getNDC().push(LOG4CPLUS_TEXT("main"));
	std::thread v([&]{ LOG4CPLUS_INFO(logger,"New thread"); });
	LOG4CPLUS_INFO(logger,"Org thread"); 
	auto KeepMainThreadNDCStackHere=log4cplus::getNDC().cloneStack(); //メインスレッドでNDC状態を保存
	std::thread w([&]{
		log4cplus::getNDC().inherit(KeepMainThreadNDCStackHere);
		LOG4CPLUS_INFO(logger,"同じコンテキストNew");
	});
	LOG4CPLUS_INFO(logger,"同じコンテキストOrg"); 
	v.join();
	w.join();
	return 0;
}
